﻿Public Class Form1

    Dim s As String
    Dim cr As FarPoint.Win.Spread.Model.CellRange
    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        ListBox1.AllowDrop = True
        FpSpread2.AllowDrop = True
        FpSpread2.AllowDragDrop = True

        cr = New FarPoint.Win.Spread.Model.CellRange(0, 0, 1, 1)
        s = FpSpread1.ActiveSheet.GetClip(0, 0, 1, 1)

        Dim pathname As String
        pathname = Environment.GetFolderPath(Environment.SpecialFolder.ProgramFiles) & "\GrapeCity\Spread Studio 8\Common\"

        Dim conStr As String = "Provider=Microsoft.JET.OLEDB.4.0;data source= " + pathname + "Patients2000.mdb"
        Dim sqlStr As String = "SELECT * FROM Patients"
        Dim conn As New System.Data.OleDb.OleDbConnection(conStr)
        Dim ds As New DataSet()
        Dim da As New System.Data.OleDb.OleDbDataAdapter(sqlStr, conn)
        FpSpread1.ActiveSheet.DataAutoSizeColumns = True
        da.Fill(ds)
        FpSpread1.ActiveSheet.DataSource = ds

        cr = New FarPoint.Win.Spread.Model.CellRange(0, 0, 1, 1)
        s = FpSpread1.ActiveSheet.GetClip(0, 0, 1, 1)
    End Sub

    Private Sub FpSpread2_DragDrop(sender As Object, e As DragEventArgs) Handles FpSpread2.DragDrop
        Dim r, c, rc, cc As Integer
        r = cr.Row
        c = cr.Column
        rc = cr.RowCount
        cc = cr.ColumnCount
        Dim sel As FarPoint.Win.Spread.Model.CellRange = FpSpread2.ActiveSheet.GetSelection(0)
        If Not (sel Is Nothing) Then
            FpSpread2.ActiveSheet.SetClip(sel.Row, sel.Column, sel.RowCount, sel.ColumnCount, s)

        End If
    End Sub

    Private Sub FpSpread2_DragEnter(sender As Object, e As DragEventArgs) Handles FpSpread2.DragEnter
        If e.Data.GetDataPresent(DataFormats.Text) Then
            e.Effect = DragDropEffects.Move
        End If
    End Sub

    Private Sub FpSpread2_DragOver(sender As Object, e As DragEventArgs) Handles FpSpread2.DragOver
        Dim r, c, rc, cc As Integer
        r = cr.Row
        c = cr.Column
        rc = cr.RowCount
        cc = cr.ColumnCount
        Dim p As Point = FpSpread2.PointToClient(New Point(e.X, e.Y))
        Dim range As FarPoint.Win.Spread.Model.CellRange = FpSpread2.GetCellFromPixel(0, 0, p.X, p.Y)
        If range.ColumnCount = -1 And range.RowCount = -1 Then
            Return
        End If
        Dim sel As FarPoint.Win.Spread.Model.CellRange = FpSpread2.ActiveSheet.GetSelection(0)
        If Not (sel Is Nothing) Then
            FpSpread2.ActiveSheet.RemoveSelection(sel.Row, sel.Column, sel.RowCount, sel.ColumnCount)
        End If

        If cc = -1 Then
            FpSpread2.ActiveSheet.AddSelection(range.Row, -1, rc, -1)
        ElseIf rc = -1 Then
            FpSpread2.ActiveSheet.AddSelection(-1, range.Column, -1, cc)
        Else
            FpSpread2.ActiveSheet.AddSelection(range.Row, range.Column, rc, cc)
        End If

    End Sub

    Private Sub FpSpread1_MouseDown(sender As Object, e As MouseEventArgs) Handles FpSpread1.MouseDown
        If e.Button = MouseButtons.Right Then
            FpSpread1.DoDragDrop(s, DragDropEffects.Copy Or DragDropEffects.Move)
        End If
    End Sub

    Private Sub FpSpread1_MouseUp(sender As Object, e As MouseEventArgs) Handles FpSpread1.MouseUp
        Try
            cr = FpSpread1.ActiveSheet.GetSelection(0)
            s = FpSpread1.ActiveSheet.GetClip(cr.Row, cr.Column, cr.RowCount, cr.ColumnCount)
        Catch ex As Exception
            MessageBox.Show("You did not make a selection!")
            Return
        End Try
    End Sub

    Private Sub ListBox1_DragDrop(sender As Object, e As DragEventArgs) Handles ListBox1.DragDrop
        Dim listitem As String
        listitem = FpSpread1.Sheets(0).GetText(FpSpread1.Sheets(0).ActiveRowIndex, FpSpread1.Sheets(0).ActiveColumnIndex)
        ListBox1.Items.Add(listitem)
    End Sub


    Private Sub ListBox1_DragOver(sender As Object, e As DragEventArgs) Handles ListBox1.DragOver
        If (e.Data.GetDataPresent(DataFormats.Text)) Then
            e.Effect = DragDropEffects.Move
        End If
    End Sub
End Class
